/*
 * Copyright [2022] [https://www.xiaonuo.vip]
 *
 * Snowy采用APACHE LICENSE 2.0开源协议，您在使用过程中，需要注意以下几点：
 *
 * 1.请不要删除和修改根目录下的LICENSE文件。
 * 2.请不要删除和修改Snowy源码头部的版权声明。
 * 3.本项目代码可免费商业使用，商业使用请保留源码和相关描述文件的项目出处，作者声明等。
 * 4.分发源码时候，请注明软件出处 https://www.xiaonuo.vip
 * 5.不可二次分发开源参与同类竞品，如有想法可联系团队xiaonuobase@qq.com商议合作。
 * 6.若您的项目无法满足以上几点，需要更多功能代码，获取Snowy商业授权许可，请在官网购买授权，地址为 https://www.xiaonuo.vip
 */

package com.unis.safeStorage.modular.device.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollStreamUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.unis.basic.info.modular.orgInfo.entity.OrgInfo;
import com.unis.safeStorage.modular.device.entity.Devicerepair;
import com.unis.safeStorage.modular.device.mapper.DeviceMapper;
import com.unis.safeStorage.modular.device.service.DeviceService;
import com.unis.safeStorage.modular.sspatrolpoint.param.DevicePageParam;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import com.unis.common.enums.CommonSortOrderEnum;
import com.unis.common.exception.CommonException;
import com.unis.common.page.CommonPageRequest;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;


/**
 * 维保管理
 *
 * @author shine
 * @date  2024/05/30 17:34
 **/

@Service
public class DeviceServiceImpl<DeviceServiceMapper> implements DeviceService {

    @Resource
    private DeviceMapper deviceMapper;

    @Override
    public IPage<Map<String, Object>> findPage(DevicePageParam devicePageParam) {
        QueryWrapper<Devicerepair> queryWrapper = new QueryWrapper<>();
        //分页相关
        if (devicePageParam.getOrgName() != null) {
            queryWrapper.like("b.org_name", devicePageParam.getOrgName());
        }
        if (devicePageParam.getDeviceName() != null) {
            queryWrapper.like("a.device_name", devicePageParam.getDeviceName());
        }

        Page<Devicerepair> p = new Page<>(devicePageParam.getCurrent(), devicePageParam.getSize());

        IPage<Map<String, Object>> page = deviceMapper.findPage(p, queryWrapper);

        return page;
    }

    @Override
    public Devicerepair loadDataById(String id) {
        return deviceMapper.loadDataById(id);
    }

    @Override
    public void updateById(Map<String,Object> map) {
         deviceMapper.updateById(map);
    }

    @Override
    public Map<String, Object> getNumber() {
        Map<String, Object> map = new HashMap<String, Object>();
        String wxsbzs = deviceMapper.getwxsbzs();
        String wxzsbsl = deviceMapper.getwxzsbsl();
        String sjclts = deviceMapper.getsjclts();
        map.put("wxsbzs",wxsbzs);
        map.put("wxzsbsl",wxzsbsl);
        map.put("sjclts",sjclts);
        return map;
    }
}

